header {
package org.antlr.java.crossref;
import java.util.Stack;
}
/** Java 1.3 AST Recognizer Grammar
 *
 * Author: (see java.g preamble)
 *
 * This grammar is in the PUBLIC DOMAIN
 */
class JavaRefsTreeParser extends JavaTreeParser;

options {
	importVocab = Java;
    ASTLabelType = "org.antlr.java.crossref.LocationAST";
}

{
	static final boolean printDebug = true;
//    DebugStack scopeStack = new DebugStack();
    Stack scopeStack = new Stack();
    CodeProject project = null;
    MethodScope currentMethodScope = null;

    public void setProject(CodeProject project) {
        this.project = project;
    }

    protected String fileName = null;
    public void setFileName(String f) {
        fileName = f;
    }
}

compilationUnit
{
	String packageName = null;
}
    :
		( packageName=packageDefinition
		{
	        String fullName = new String(packageName + "." + fileName);
		    FileScope fs = project.getFileScope(fullName);
		    scopeStack.push(fs);
		}
		|	/* nothing */
		{
	        String fullName = new String("[default]." + fileName);
		    FileScope fs = project.getFileScope(fullName);
		    scopeStack.push(fs);
		}
		)
		(importDefinition)*
		(typeDefinition)*
		{scopeStack.pop();}
	;

packageDefinition  returns [String id = null]
	:	#( PACKAGE_DEF id=identifier )
	;

// Added import Scope added to file Scope in PRE-REFS
//importDefinition
//	:	#( IMPORT packageOrClassIdentifier )
//	;

/** only called from importDefinition */
// Added import Scope added to file Scope in PRE-REFS
//packageOrClassIdentifier
//{
//    String r = null;
//    Scope scope = null;
//}
//	:	IDENT
//        {
//// Added import Scope added to file Scope in PRE-REFS
////        FileScope currentScope = (FileScope)scopeStack.peek();
////        ClassScope cs=project.getClassScope(#IDENT.getText());
////        currentScope.addImport(cs);
//		//if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
//        // System.out.println("JavaRefsTreeParser:packageOrClassIdentifier " + "import class "+scope);
//        }
//	|	#( DOT r=identifier
//           (    STAR
//                {
//// Added import Scope added to file Scope in PRE-REFS
////                FileScope currentScope = (FileScope)scopeStack.peek();
////                scope = project.getPackageScope(r);
////                currentScope.addImport(scope);
//   				//if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
//                // System.out.println("JavaRefsTreeParser:packageOrClassIdentifier " + "import "+scope);
//                }
//           |    IDENT
//                {
////                String id=r+"."+#IDENT.getText();
////                FileScope currentScope = (FileScope)scopeStack.peek();
////                ClassScope cs=project.getClassScope(id);
////                currentScope.addImport(cs);
//				//if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
//                // System.out.println("JavaRefsTreeParser:packageOrClassIdentifier " + "import class "+cs);
//                }
//           )
//         )
//	;

typeDefinition
{
    ClassScope cs = null;
}
:	#(  CLASS_DEF modifiers IDENT
            {	if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
            		System.out.println("JavaRefsTreeParser:typeDefinition " + "class "+#IDENT.getText());}
            {
            Scope currentScope = (Scope)scopeStack.peek();
            String pName = currentScope.getFullyQualifiedName();
            cs = project.getClassScope(pName+"."+#IDENT.getText());
            }
//            extendsClause[cs] implementsClause[cs]
            extendsClause implementsClause
            {scopeStack.push(cs);}
            objBlock
            {scopeStack.pop();}
         )
	|	#(  INTERFACE_DEF modifiers IDENT
            {if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
            	System.out.println("JavaRefsTreeParser:typeDefinition " + "interface "+#IDENT.getText());}
            {
            Scope currentScope = (Scope)scopeStack.peek();
            String pName = currentScope.getFullyQualifiedName();
            cs = project.getClassScope(pName+"."+#IDENT.getText());
            }
//            extendsClause[cs]
			extendsClause
            {scopeStack.push(cs);}
            interfaceBlock
            {scopeStack.pop();}
         )
	;

// Resolved extends clause in PRE-REFS
//extendsClause[ClassScope def]
//{
//    String id = null;
//}
//	:	#(  EXTENDS_CLAUSE
//            (   id=identifier
//                {
//                Scope currentScope = (Scope)scopeStack.peek();
//                ClassScope cs = currentScope.resolveClass(id);
//                def.addSuperClass(cs);
//                }
//            )*
//         )
//         {
//         if ( def!=null && def.getSuperClasses()==null ) {
//            ClassScope o = project.getClassScope("java.lang.Object");
//            def.addSuperClass(o);
//         }
//         }
//	;

// Added import Scope added to file Scope in PRE-REFS

//implementsClause[ClassScope def]
//{
//    String id = null;
//}
//	:	#(  IMPLEMENTS_CLAUSE
//            (   id=identifier
//                {
//                Scope currentScope = (Scope)scopeStack.peek();
//                ClassScope cs = currentScope.resolveClass(id);
//                def.addImplementedInterface(cs);
//                }
//            )*
//         )
//	;


interfaceBlock
	:	#(	OBJBLOCK
			(	methodDecl
			|	variableDef
			)*
		)
	;

typeSpec returns [ClassScope t=null]
	:	#(TYPE t=typeSpecArray)
	;

typeSpecArray returns [ClassScope t=null]
	:	#( ARRAY_DECLARATOR t=typeSpecArray )
	|	t=type
	;

type returns [ClassScope t=null]
{
    String r=null;
}
    :	r=id:identifier
        {
	        Scope currentScope = (Scope)scopeStack.peek();
    	    t = currentScope.resolveClass(r);
			if(t != null)
	    	    project.refElement(currentScope, t, id);
        }
	|	bt:builtInType
	{
		t = project.getClassScope(bt.getText());
	}
	;

objBlock
	:	#(	OBJBLOCK
			(	ctorDef
			|	methodDef
			|	fieldDef
			|	typeDefinition
			|	#(STATIC_INIT slist)
			|	#(INSTANCE_INIT slist)
			)*
		)
	;

fieldDef
{
    ClassScope t = null;
}
	:	#(VARIABLE_DEF modifiers t=typeSpec fieldDeclarator[t] varInitializer)
	;

fieldDeclarator[ClassScope t]
	:	IDENT
        {
            // set types of all fields now that we can resolve refs
            ClassScope currentScope = (ClassScope)scopeStack.peek();
            FieldVariable f = currentScope.getField(#IDENT.getText());
//  PREREF          f.setType(t);
//            May need "f" for varInitializer
        }
	|	LBRACK fieldDeclarator[t]
	;

methodDef
{
    ClassScope retType = null; // either class name or we don't care
}
	:	#(METHOD_DEF modifiers retType=typeSpec methodHead[retType] (slist)?)
        {scopeStack.pop(); scopeStack.pop();}
	;

ctorDef
	:	#(CTOR_DEF modifiers methodHead[null] (slist)?)
        {scopeStack.pop(); scopeStack.pop();}
	;

methodDecl
{
    ClassScope retType = null; // either class name or we don't care
}
	:	#(METHOD_DEF modifiers retType=typeSpec methodHead[retType])
	    {scopeStack.pop(); scopeStack.pop();}
	;

methodHead[ClassScope retType]
{
  Scope currentScope = (Scope)scopeStack.peek();
  String pName = currentScope.getFullyQualifiedName();
  StringBuffer signature = new StringBuffer();
  String temp;
  String identifier=null;
}
	:	IDENT
        {
        	identifier=#IDENT.getText();
        	//setup for parameters
        	signature.append("(");
        }
      #( PARAMETERS 
			(temp=parameterDef
			{ if( temp != null)
        		signature.append(Signature.typeToSignature(temp)); 
          	  else
        		signature.append(Signature.UNKNOWN); 
        	
			}
	
			)* 
		)
      {
      	signature.append(")");
            MethodScope ms = project.getMethodScope(pName+"."+identifier, signature.toString());
            if ( ms!=null ) {
                scopeStack.push(ms);
                ParameterScope ps = ms.getParameterScope();
                scopeStack.push(ps);
                currentMethodScope = ms;
            }
            else {
				if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
                	System.err.println("JavaRefsTreeParser:methodHead " + "# cannot find method "+pName+"."+#IDENT.getText());
            }
      }
       (throwsClause)?
	;

parameterDef returns [String vartype=null]
{
    ClassScope t = null;
}
	:	#(PARAMETER_DEF modifiers t=typeSpec paramDef:IDENT )
        {
            if(t != null)
	            vartype = t.getFullyQualifiedName();
        }
	;

throwsClause
{
    String r = null;
}
//	:	#(  EXTENDS_CLAUSE
//            (   id=identifier
//                {
//                Scope currentScope = (Scope)scopeStack.peek();
//                ClassScope cs = currentScope.resolveClass(id);
//                def.addSuperClass(cs);
//                }
//            )*

	:	#( "throws" 
	( r=id:identifier
      {
      	Scope currentScope = (Scope)scopeStack.peek();
        ClassScope cs = currentScope.resolveClass(r);
        project.refClass(currentMethodScope, cs, id);
      }
	)* )
	;

slist
	:	#(  sl:SLIST
            {
            Scope currentScope = (Scope)scopeStack.peek();
            CodeBlockScope cbs =
                new CodeBlockScope(project,"[slist]",currentScope);
            cbs.setSourceLocation(fileName, sl.getLine(), sl.getColumn());
            currentScope.addScopeMember(cbs);
            scopeStack.push(cbs);
            }
            (stat)*
            {Scope s = (Scope)scopeStack.pop(); 
           	if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
	           	{
               	System.err.println("JavaRefsTreeParser:slist") ;
				s.dump(); 
    	       	}
            }
         )
	;

variableDef
{
    ClassScope t = null;
}
	:	#(VARIABLE_DEF modifiers t=typeSpec variableDeclarator[t] varInitializer)
	;

variableDeclarator[ClassScope t]
	:	varDecl:IDENT
        {
            Scope currentScope = (Scope)scopeStack.peek();
            LocalVariable local =
                new LocalVariable(project,varDecl.getText(),currentScope);
            local.setSourceLocation(fileName, varDecl.getLine(), varDecl.getColumn());
            local.setType(t);
            currentScope.addScopeMember(local);
        }
	|	LBRACK variableDeclarator[t]
	;
//Done in PREREFS,  no push/pop scope
//parameterDef
//{
//    ClassScope t = null;
//}
//	:	#(PARAMETER_DEF modifiers t=typeSpec IDENT )
//        {
//            Scope currentScope = (Scope)scopeStack.peek();
//            LocalVariable local =
//                new LocalVariable(project,#IDENT.getText(),currentScope);
//            local.setType(t);
//            currentScope.addScopeMember(local);
//        }
//	;

objectOrClassIdentifier returns [ClassScope t=null]
{
    ClassScope tScope = null;
}
	:	OOCIdent1:IDENT 
        {
        Scope currentScope = (Scope)scopeStack.peek();
        Scope sc = project.resolveTypeOrField(currentScope, OOCIdent1.getText());
		if(sc instanceof Variable)
			t = ((Variable) sc).getType();
		else
			t = (ClassScope) sc;
		project.refElement(currentScope, sc, OOCIdent1);
        }
	|	#( DOT tScope=objectOrClassIdentifier OOCIdent2:IDENT ) 
	  {
        if(tScope != null)
        {
	        Scope currentScope = (Scope)scopeStack.peek();
        	Scope sc = project.resolveTypeOrField(tScope, OOCIdent2.getText());
			if(sc instanceof Variable)
				t = ((Variable) sc).getType();
			else
				t = (ClassScope) sc;
			project.refElement(currentScope, sc, OOCIdent2);
        }
	  }
	;

identifier returns [String id=null]
{
    String r = null;
}
	:	IDENT {id=#IDENT.getText();}
	|	#( DOT r=identifier IDENT ) {id=r+"."+#IDENT.getText();}
	;
constant returns [ClassScope t = null]
    :   NUM_INT
    |   CHAR_LITERAL
    |   STRING_LITERAL
    |   NUM_FLOAT
    |   NUM_DOUBLE
    |   NUM_LONG
    ;
	

primaryExpression returns [ClassScope t=null]
{
    ClassScope objOrTypeScope = null;
    Scope typeOrFieldScope = null;
    String signature = null;
}
    :   id:IDENT
    {
        Scope currentScope = (Scope)scopeStack.peek();
        typeOrFieldScope = project.resolveTypeOrField(currentScope, id.getText());
        if(typeOrFieldScope instanceof Variable)
        	t = ((Variable) typeOrFieldScope).getType();
        else
        	t = (ClassScope) typeOrFieldScope;
		project.refElement(currentScope, typeOrFieldScope, id);
    }
    
    |   #(	DOT
			(	objOrTypeScope = expr
				(	subId:IDENT 
				{
	                if ( objOrTypeScope!=null ) 
	                {
        	            ClassScope cs = null;
				        Scope currentScope = (Scope)scopeStack.peek();
        	            typeOrFieldScope = project.resolveTypeOrField(objOrTypeScope, subId.getText());
				        if(typeOrFieldScope instanceof Variable)
        					cs = ((Variable) typeOrFieldScope).getType();
				        else
				        	cs = (ClassScope) typeOrFieldScope;
						project.refElement(currentScope, typeOrFieldScope, subId);
            	        if ( cs!=null ) 
                    	    t = cs;
    	            }
				}
				|	arrayIndexInMethodCallExpression
				|	"this" {t=objOrTypeScope;}
				|	"class" {t=objOrTypeScope;}
				//How does this piece of grammar get realized?
				//Should this be t = currentScope.resolveClass();
				|	#( "new" newId:IDENT signature=elist )
                    {
                    t = objOrTypeScope.resolveClass(newId.getText());
			        Scope currentScope = (Scope)scopeStack.peek();
					if(t != null)
					{
						MethodScope ms = t.resolveMethod(newId.getText(), signature);
						project.refElement(currentScope, ms, newId);
					}
					else
						project.refElement(currentScope, null, newId);
                    }
				|   spr:"super"
				{
					t = objOrTypeScope.getSuperClass();
			        Scope currentScope = (Scope)scopeStack.peek();
					project.refElement(currentScope,  t, spr);
				}
				)
			|	#(ARRAY_DECLARATOR t=typeSpecArray)
			|	builtInType ("class")?
			)
		)
	|	t = arrayIndex
	|	t=methodCallExpression
	|	#(TYPECAST t=typeSpec expr)
	|   t=newExpression
	|   t=constant
    |   sp:"super"
        {
        Scope currentScope = (Scope)scopeStack.peek();
        ClassScope cs = currentScope.getNearestClass();
        t=cs.getSuperClass();
        project.refElement(currentScope, t, sp);
        }
    |   "true"
    |   "false"
    |   ths:"this"
    {
        Scope currentScope = (Scope)scopeStack.peek();
        t = currentScope.getNearestClass();
        project.refElement(currentScope, t, ths);
    }
    |   "null"
	|	t=typeSpec // type name used with instanceof
	;

/** Isolate method calls since the context information allows us
 *  to make a simpler, more explicit grammar.
 */
methodCallExpression returns [ClassScope t=null]{
    Scope objOrTypeScope = null;
	LocationAST locInfo = null;    
    Scope currentScope = (Scope)scopeStack.peek();
	String signature = null;
}
:#(  METHOD_CALL
	(   m1:IDENT
		{
		objOrTypeScope = (Scope)scopeStack.peek();
		locInfo = m1;
//		currMethodScope = currentMethodScope;
		}
		| #( DOT objOrTypeScope=objectOrClassExpression m2:IDENT )
		{
			locInfo = m2;
//			currMethodScope = currentMethodScope;
		}
	)
	signature=elist
	{
	if ( objOrTypeScope!=null ) 
	{
		MethodScope ms = objOrTypeScope.resolveMethod(locInfo.getText(), signature);
		project.refMethod(currentScope, ms, locInfo);
		if ( ms!=null ) 
			t = ms.getReturnType();
	} //if
	} //elist
)
;


elist returns [String signature=null]
{ ClassScope t=null; 
  StringBuffer buf = new StringBuffer();
  buf.append("(");
}
	:	#( ELIST 
			(t=expression
			{
			if(t != null)
			{
				String str = t.getFullyQualifiedName();
				buf.append(Signature.typeToSignature(str));
			}
			else
				buf.append("X");
			}
			
			)* 
		{   buf.append(")");
			signature = buf.toString(); }
		)
	;

objectOrClassExpression returns [ClassScope t=null]
{
    ClassScope objOrTypeScope = null;
    String id = null;
    String signature = null;
}
    :   t=methodCallExpression
    |   #(TYPECAST t=typeSpec expr)
    |   t=newId:newExpression
        {if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
        	System.out.println("JavaRefsTreeParser:objectOrClassExpression " + "new expr resolved to "+
         (t!=null?t.getFullyQualifiedName():"null"));
//		project.refElement((Scope) scopeStack.peek(), t, newId);
		}
    |   STRING_LITERAL {t=project.getClassScope("java.lang.String");}
    |   superId:"super"
        {
        ClassScope cs = (ClassScope)currentMethodScope.getParent();
        t=cs.getSuperClass();
        if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
        	System.out.println("JavaRefsTreeParser:objectOrClassExpression " + "super resolved to "+t.getFullyQualifiedName());
        project.refElement((Scope) scopeStack.peek(), t, superId);
        }
    |   thisId:"this"
        {
        t = (ClassScope)currentMethodScope.getParent(); // get class scope.
        if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
        	System.out.println("JavaRefsTreeParser:objectOrClassExpression " + "this resolved to "+t.getFullyQualifiedName());
        project.refElement((Scope) scopeStack.peek(), t, thisId);
        }

    |	t=arrayIndexInMethodCallExpression

        // com.jguru.test.Main.getName();  package.class access
        // a.foo();     field access
        // a.b.c.foo(); field access
        // Main.foo();  class method access
        // java.lang.System.out.println("JavaRefsTreeParser: " + ); package.class.field access

    |   (identifier)=> t=objectOrClassIdentifier
//  The code below is valid.  It doesn't call project.refElement() after each
//  step is resolved.  objectOrClassIdentifier takes each IDENT individually.
//    |   (identifier)=> id=idIdent:identifier
//        {
//        if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
//        	System.out.println("JavaRefsTreeParser:objectOrClassExpression " + "qname (class or field) ref "+id);
//        Scope currentScope = (Scope)scopeStack.peek();
//        Scope sc = project.resolveTypeOrField(currentScope, id);
//		if(sc instanceof Variable)
//			t = ((Variable) sc).getType();
//		else
//			t = (ClassScope) sc;
//		project.refElement(currentScope.getNearestClassOrMethodScope(), sc, idIdent);
//        }

        /*
    |   // Used with Main.foo() or user.getName(); must be class or var/field
        IDENT
        {
        if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
        	System.out.print("ID ref "+#IDENT.getText());
        Scope currentScope = (Scope)scopeStack.peek();
        Variable v = currentScope.resolveVariable(#IDENT.getText());
        if ( v!=null ) {
            if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
            	System.out.print("var resolved to ");
            v.dump();
            t = v.getType();
        }
        }
        */

    |   #(  DOT
            (   objOrTypeScope=objectOrClassExpression
				(	id1:IDENT
                    {
                    if ( objOrTypeScope!=null ) {
                        FieldVariable f = objOrTypeScope.resolveField(id1.getText());
                        if ( f!=null ) {
                            t = f.getType();
                        }
						project.refElement((Scope) scopeStack.peek(), t, id1);
                    }
                    }
				|	"this" {t=objOrTypeScope;}
				|	"class"{t=objOrTypeScope;}
				|	#( "new" id2:IDENT signature=elist )
                    {
                    Scope currentScope = (Scope)scopeStack.peek();
                    t = currentScope.resolveClass(id2.getText());
					MethodScope ms = currentScope.resolveMethod(id2.getText(), signature);
					if(ms == null)
						project.refElement(currentScope, t, id2);
					else
						project.refElement(currentScope, ms, id2);
					//project.refElement(currentScope, t, #id2);
                    }
				)
			|	builtInType "class"
            )
         )
    ;

newExpression returns [ClassScope t=null]
{
	String signature = null;
   	Scope currentScope = (Scope) scopeStack.peek();
}
	:	#(	"new" t=idt:type
			(	newArrayDeclarator (arrayInitializer)?
			|	signature=elist 
			{
				if(t != null)
				{
					MethodScope ms = t.resolveMethod(idt.getText(), signature);
					project.refElement(currentScope, ms, idt);
				}
				else
					project.refElement(currentScope, null, idt);
				
			}
			    (objBlock)?
			)
		)
	;

arrayName returns [ClassScope t=null]
    :   t=objectOrClassExpression
    |   #(QUESTION expr expr expr)	// trinary operator
        // ambiguous; ignore these
    ;

arrayIndexInMethodCallExpression returns [ClassScope t=null]
	:	#(INDEX_OP t=arrayName expression)
        {if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
        	System.out.println("JavaRefsTreeParser:arrayIndexInMethodCallExpression " + "array ref of type "+t.getFullyQualifiedName());}
	;

stat:	typeDefinition
	|	variableDef
	|	expression
	|	#(LABELED_STAT IDENT stat)  //implement LABELs later
	|	#("if" expression stat (stat)? )
	|	#(	fr:"for"
	      {//Make a temporary scope for "for" loop
	       //Objective is to set temporary space for resolving
	       // local variable defined in loop.  Goes away after statements
            Scope currentScope = (Scope)scopeStack.peek();
            CodeBlockScope cbs =
                new CodeBlockScope(project,"[slist]",currentScope);
            cbs.setSourceLocation(fileName, fr.getLine(), fr.getColumn());
			currentScope.addScopeMember(cbs);
            scopeStack.push(cbs);
            }
			#(FOR_INIT (variableDef | elist)?)
			#(FOR_CONDITION (expression)?)
			#(FOR_ITERATOR (elist)?)
			stat
            {Scope s = (Scope)scopeStack.pop(); 
           	if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
				s.dump(); 
            }
		)
	|	#("while" expression stat)
	|	#("do" stat expression)
	|	#("break" (IDENT)? ) //implement LABELs later
	|	#("continue" (IDENT)? ) //implement LABELs later
	|	#("return" (expression)? )
	|	#("switch" expression (caseGroup)*)
	|	#("throw" expression)
	|	#("synchronized" expression stat)
	|	tryBlock
	|	slist // nested SLIST
    // uncomment to make assert JDK 1.4 stuff work
    // |   #("assert" expression (expression)?)
	|	EMPTY_STAT
	;

//tryBlock needs a temp scope
handler
//Other parameterdefs are saved off.
	:	#( "catch" 
	    {//Make a temporary scope for "catch" 
        	Scope currentScope = (Scope)scopeStack.peek();
            CodeBlockScope cbs =
                new CodeBlockScope(project,"[slist]",currentScope);
			currentScope.addScopeMember(cbs);
            scopeStack.push(cbs);
		}
     	catchParameterDef 
     	slist 
     	{ //begin action
     		Scope s = (Scope)scopeStack.pop(); 
         if(JavaRefsTreeParser.printDebug && CodeProject.printDebug)
			s.dump();
		} //end action squiggly
     	) //end of # "catch" right paren
	;

catchParameterDef
{
    ClassScope t = null;
}
	:	#(PARAMETER_DEF modifiers t=typeSpec paramDef:IDENT )
        {
            Scope currentScope = (Scope)scopeStack.peek();
            LocalVariable local =
                new LocalVariable(project,paramDef.getText(),currentScope);
            local.setSourceLocation(fileName, paramDef.getLine(), paramDef.getColumn());
            local.setType(t);
            currentScope.addScopeMember(local);
        }
	;

expression returns [ClassScope t=null]
	:	#(EXPR t=expr)
	;

expr returns [ClassScope t=null]
	:	#(QUESTION expr expr expr)	// trinary operator
	|	#(ASSIGN expr expr)			// binary operators...
	|	#(PLUS_ASSIGN expr expr)
	|	#(MINUS_ASSIGN expr expr)
	|	#(STAR_ASSIGN expr expr)
	|	#(DIV_ASSIGN expr expr)
	|	#(MOD_ASSIGN expr expr)
	|	#(SR_ASSIGN expr expr)
	|	#(BSR_ASSIGN expr expr)
	|	#(SL_ASSIGN expr expr)
	|	#(BAND_ASSIGN expr expr)
	|	#(BXOR_ASSIGN expr expr)
	|	#(BOR_ASSIGN expr expr)
	|	#(LOR expr expr)
	|	#(LAND expr expr)
	|	#(BOR expr expr)
	|	#(BXOR expr expr)
	|	#(BAND expr expr)
	|	#(NOT_EQUAL expr expr)
	|	#(EQUAL expr expr)
	|	#(LT expr expr)
	|	#(GT expr expr)
	|	#(LE expr expr)
	|	#(GE expr expr)
	|	#(SL expr expr)
	|	#(SR expr expr)
	|	#(BSR expr expr)
	|	#(PLUS expr expr)
	|	#(MINUS expr expr)
	|	#(DIV expr expr)
	|	#(MOD expr expr)
	|	#(STAR expr expr)
	|	#(INC expr)
	|	#(DEC expr)
	|	#(POST_INC expr)
	|	#(POST_DEC expr)
	|	#(BNOT expr)
	|	#(LNOT expr)
	|	#("instanceof" expr expr)
	|	#(UNARY_MINUS expr)
	|	#(UNARY_PLUS expr)
	|	t=primaryExpression
	;
//  jfo: I see arrayIndex as expr[expression]
arrayIndex returns [ClassScope t=null]
	:	#(INDEX_OP t=expr expression)
	;
	
	